/* See LICENSE of license details. */

#include <errno.h>
#include <stdint.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdint.h>

#include "platform.h"
#include "stub.h"
#include "weak_under_alias.h"
#if defined(SEMIHOSTING)
#include "semihosting.h"
#endif

extern uint32_t tohost;

ssize_t __wrap_write(int fd, const void *ptr, size_t len) {
  const uint8_t *current = (const uint8_t *)ptr;
#if defined(SEMIHOSTING)
  if (isatty(fd)) {
    for (size_t jj = 0; jj < len; jj++) {
      sh_writec(current[jj]);
    }
    return len;
  } else {
    sh_write(current, fd);
    return len;
  }
  // return len;
#elif defined(BOARD_iss)
  volatile uint64_t payload[4];
  payload[0]= 64;
  payload[1]= 0;
  payload[2]= (uintptr_t)ptr;
  payload[3]= len;
  tohost = (uint32_t)payload;
  return len;
#endif
  if (isatty(fd)) {
    for (size_t jj = 0; jj < len; jj++) {
#if defined(BOARD_ehrenberg) || defined(BOARD_tgc_vp)
      while (get_uart_rx_tx_reg_tx_free(uart) == 0)
        ;
      uart_write(uart, current[jj]);
      if (current[jj] == '\n') {
        while (get_uart_rx_tx_reg_tx_free(uart) == 0)
          ;
        uart_write(uart, '\r');
      }
#elif defined(BOARD_iss)
      // *((uint32_t *)0xFFFF0000) = current[jj];
#elif defined(BOARD_TGCP)
      // TODO: implement
#else
      while (UART0_REG(UART_REG_TXFIFO) & 0x80000000)
        ;
      UART0_REG(UART_REG_TXFIFO) = current[jj];

      if (current[jj] == '\n') {
        while (UART0_REG(UART_REG_TXFIFO) & 0x80000000)
          ;
        UART0_REG(UART_REG_TXFIFO) = '\r';
      }
#endif
    }
    return len;
  }

  return _stub(EBADF);
}
weak_under_alias(write);
